#include"phone.h"
#include<string>
#include<iostream>
using namespace std;

//I AM NOT CONCERNED ABOUT VALIDATION, SO ANYTHING GOES
//APART FROM NEGATIVE PRICES
void phone::setMake(string ma) {make = ma;}
void phone::setModel(string mo) {model = mo;}
void phone::setPrice(double pr) {price=(pr>=0 ? pr : 0);}
string phone::getMake() {return make;}
string phone::getModel() {return model;}
double phone::getPrice() { return price;}
//constructor

phone::phone(string ma, string mo, double pr)
{
	setMake(ma);
	setModel(mo);
	setPrice(pr);
}

void phone::print()
{
	cout << "PHONE: " << make << ", " << model << " (" << price << ")\n";
}

//OPERATOR OVERLOADING BELOW
//						cout    <<    object
ostream& operator<<(ostream& output, phone& object)
{
	output << "PHONE: " << object.make << ", " << object.model << " (" << object.price << ")\n";
	
	//to enable cascading calls
	//cout << int << phone << double << comment << phone
	return output;
}

/*to enable cascading calls
phone p; int a = 10, b, c;
cout << p << a << b << c;	//1st output the p and then
   cout   << a << b << c;
        cout   << b << c;
		     cout   << c;
			      cout; 
*/
















//more operator overloading

	//						cin      >>   phone
	istream& operator>>(istream& input, phone& object)
	{
		//prompt the user
		cout << "Please enter the details for the phone\n : (make model price): ";
		
		//option 1
		{
		//we take for granted that the user will not make mistakes 
		//and we assign directly 
		//input >> object.make >> object.model >> object.price;
		}
		
		//OR option 2
		{
		//we read in the values to temporary variables and then
		//use the respective set methods to change the object
		//therefore not bypassing validation
		//*
		string ma = "";
		string mo = "";
		double pr = 0;
		input >> ma >> mo >> pr;
		object.setMake(ma); 		
		object.setModel(mo);
		object.setPrice(pr); 		
		//*/
		}
		
		//finally return to enable cascading calls
		// cin >> phone >> int >> phone >> double;
		return input;
	}	







