#ifndef SHAPE
#define SHAPE
#include<string>
using namespace std;
class shape{
	private:
		string name;
	protected:
		int faces;
		int edges;
		int vertices;
	
	public:
		/* THIS IS AN ABSTRACT CLASS */
		// it specifies 4 pure virtual functions
		virtual double perimeter()=0; 
		virtual double volume()=0;
		virtual double area()=0;
		virtual string draw()=0;
		
		void setName(string arg);
		void setEdges(int arg);
		void setFaces(int arg);
		void setVertices (int arg);
		
		string getName();
		int getEdges();
		int getFaces();
		int getVertices();
		
		shape(string n="shape", int e=0, int f=0, int v=0);
};
#endif
