#ifndef TRIANGLE
#define TRIANGLE
#include"shape2d.h"
#include"vertex.h"
#include"edge.h"
class triangle : public shape2d {
	private:
		vertex top;
		vertex leftVertex;
		vertex rightVertex;
		edge base;
		edge leftEdge;
		edge rightEdge;
	public:
		void setTop(vertex arg);
		void setRightVertex(vertex arg);
		void setLeftVertex(vertex arg);
		void setBase(edge arg);
		void setRightEdge(edge arg);
		void setLeftEdge(edge arg);
		
		vertex getTop();
		vertex getLeftVertex();
		vertex getRightVertex();
		edge getBase();
		edge getLeftEdge();
		edge getRightEdge();
		
		triangle (string n="triangle", 
			vertex leftv= vertex("left v", 0, 0, 0), 
			vertex rigtv = vertex("right v", 1, 0, 0), 
			vertex topv = vertex("topv", 1, 1, 0),
			edge base = edge("base edge", vertex("base_start", 0,0,0), vertex("base_end", 1, 0, 0)), 
			edge left = edge("left edge", vertex("left_start", 0,0,0), vertex("left_end", 1, 1, 0)), 
			edge right = edge("right edge", vertex("right_start", 1, 1, 0), vertex("right_end", 1, 0, 0)));
		
		//override
		void setEdges(int arg);
		void setVertices(int arg);
		
		/* THIS CLASS IS CONCRETE */
		double perimeter();
		double area();
		double volume();
		string draw();
	
	
};
#endif
