#include"shape.h"
#include"shape2d.h"
#include"shape3d.h"
#include"vertex.h"
#include"edge.h"
#include"triangle.h"
#include<iostream>
#include<iomanip>
using namespace std;
int main() {
	//shape x; 		// will cause an error
	//shape2d x; 	// will cause an error
	//shape3d x; 		//will cause an error
	vertex p = vertex("start", 0, 0, 0);
	cout << p.draw() << endl;
	
	vertex q = vertex("end", 1, 0, 0);
	cout << q.draw() << endl;
	
	edge l("edge", p, q);
	cout << l.draw();
	
	triangle t;
	cout << t.draw();
	cout << "area of triangle: " << t.area();
	
	//now polymorphicly
	shape* x[] = {&p, &q, &l, &t};
	
	
	cout << "\n\nVOLUME OF ...........\n";
	for(int i=0 ; i<4 ; i++)
	{
		cout << x[i]->getName() << ": " << x[i]->volume() << endl;
	}
	cout << "\n\nAREA OF ...........\n";
	for(int i=0 ; i<4 ; i++)
	{
		cout << x[i]->getName() << ": " << x[i]->area() << endl;
	}
	cout << "\n\nPERIMETER OF ...........\n";
	for(int i=0 ; i<4 ; i++)
	{
		cout << x[i]->getName() << ": " << x[i]->perimeter() << endl;
	}
	
	
	
}
